theory Status_Impl
imports
  Term_Order_Impl
  Map_Choice
  "$AFP/Lifting_Definition_Option/Lifting_Definition_Option"
begin
type_synonym 'f status_impl = "(('f \<times> nat) \<times> nat list)list"

lift_definition_option status_of :: "'f status_impl \<Rightarrow> 'f status option" is
  "\<lambda> s :: 'f status_impl. if (\<forall> fidx \<in> set s. (\<forall> i \<in> set (snd fidx). i < snd (fst fidx)))
     then Some (fun_of_map_fun (map_of s) (\<lambda> (f,n). [0 ..< n])) else None"    
proof (intro allI)
  fix s :: "'f status_impl" and f n
  let ?s = "fun_of_map_fun (map_of s) (\<lambda> (f,n). [0 ..< n])"
  assume *: "\<forall>fidx\<in>set s. \<forall>i\<in>set (snd fidx). i < snd (fst fidx)"
  show "set (?s (f, n)) \<subseteq> {0..<n}"
  proof (cases "map_of s (f,n)")
    case (Some idx)
    from map_of_SomeD[OF Some] Some
    have "?s (f,n) = idx" "((f, n), idx) \<in> set s" by auto
    with * Some show ?thesis by auto
  qed auto
qed

lemma status_of_default: assumes s: "status_of s = Some \<sigma>"
  and f: "(f,n) \<notin> fst ` set s"
  shows "status \<sigma> (f,n) = [0 ..< n]"
proof -
  from map_of_eq_None_iff[of s "(f,n)"] f have "map_of s (f,n) = None" by simp
  thus ?thesis unfolding status_of_Some[OF s] by simp
qed
end
